<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des types d'activités</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">
          Nombre total de types d'activités : {{ total }}
        </h3>
        <div class="column is-narrow">
          <nuxt-link
            :to="{ name: 'profil-dashboard-types-activites-creer', params: { profil: 'admin' } }"
            tag="button"
            class="is-primary button"
          >
            <b-icon icon="plus" />&nbsp;&nbsp;Créer un type d'activite
          </nuxt-link>
        </div>
      </div>
      <mt-list v-slot="{ item: typeActivite }" :list="typesActivites">
        <mt-list-item>
          <div class="columns is-vcentered">
            <nuxt-link
              :to="{
                name: 'profil-dashboard-types-activites-id-editer',
                params: { profil: 'admin', id: typeActivite.id },
              }"
              class="columns column mt-marginless-bottom"
            >
              <div class="column">
                {{ typeActivite.code }}
              </div>
              <div class="column">
                {{ typeActivite.libelle }}
              </div>
              <div class="column">
                {{ typeActivite.codeCss }}
              </div>
              <div class="column">
                {{ typeActivite.codeCssIcone }}
              </div>
              <div class="column">
                {{ typeActivite.ordre }}
              </div>
            </nuxt-link>
            <div class="column is-narrow">
              <b-button type="is-danger" icon-left="delete" @click="confirmeSupprimer(typeActivite)"
                >Supprimer</b-button
              >
            </div>
          </div>
        </mt-list-item>
      </mt-list>
      <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerTypeActivite(monTypeActivite)">
        Êtes-vous certain(e) de vouloir supprimer le type d'activité ?
      </mt-modal-action>
      <b-pagination
        :total="total"
        :current="pageCourante"
        :per-page="parPage"
        order="is-centered"
        aria-next-label="Types d'activités suivants"
        aria-previous-label="Types d'activités précedents"
        aria-page-label="Types d'activités"
        aria-current-label="Page courante"
        @change="getTypesActivites"
      />
    </div>
  </div>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtModalAction from '~/components/modal/mt-modal-action';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
    MtModalAction,
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 10;
    const {
      content: typesActivites,
      totalElements: total,
      numberOfElements: nombrePageCourante,
    } = await $api.typesActivites.allPage(pageCourante - 1, parPage);
    return {
      typesActivites,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      ouvertDelete: false,
      monTypeActivite: null,
    };
  },
  methods: {
    async getTypesActivites(page) {
      this.pageCourante = page;
      ({
        content: this.typesActivites,
        totalElements: this.total,
        numberOfElements: this.nombrePageCourante,
      } = await this.$api.typesActivites.allPage(this.pageCourante - 1, this.parPage));
    },
    confirmeSupprimer(typeActivite) {
      this.ouvertDelete = true;
      this.monTypeActivite = typeActivite;
    },
    async supprimerTypeActivite(typeActivite) {
      try {
        await this.$api.typesActivites.delete(typeActivite.id);
        let page = this.pageCourante;
        if (this.nombrePageCourante === 1 && this.pageCourante > 1) {
          page = this.pageCourante - 1;
        }
        this.getTypesActivites(page);
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
.mt-marginless-bottom {
  margin-bottom: 0;
}

/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
</style>
